CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000            
  FB_CLR_Y = 16
  ROI_X = 320
  FB_CLR_Y_M1 = 15
  ROI_X_M1 = 319 
  FB_CLR_X      = 640
  LOWER_BOUND   = 75            ' Minimum brightness value (Y = 0.3)

OBJ
  Sio : "FullDuplexSerialPlus"
  
VAR
  long fb[5120]            ' Frame buffer (in longs)
  long start, end          ' time hacks
  long val, tmp, index, fbPtr, iy, ix
  byte roi[ROI_X]
PUB Main   
  Sio.Start(31, 30, 0, 115200)
  waitcnt(clkfreq * 3 + cnt)
  fbPtr := @fb
'********************** original code
  start := cnt
  repeat iy from 0 to (FB_CLR_Y - 1)                  ' for each row Y     {** 16 **}
    repeat ix from 0 to (ROI_X - 1)         {** 320 **}' for each column X within our region-of-interest (we only care about the left side of the frame - anything on the right is not our laser) 
      index := ((iy * FB_CLR_X) + ix) * 2                 ' calculate index, look at every other byte of the frame buffer
      val := BYTE[fbPtr][index]                             ' read value from memory
      
      if (val > LOWER_BOUND)                              ' if pixel's Y component is above the lower brightness bound, then pixel is "valid"
        roi[ix] += 1                                        ' so, increment count for the current column
  end := cnt
  Sio.dec(end - start)      ' 31403152 ticks 327 milliseconds
  sio.tx(13)
'********************** faster code uses same data as original code 
  start := cnt
  repeat iy from 0 to constant(FB_CLR_Y - 1)                  ' for each row Y     {** 16 **}
    repeat ix from 0 to constant(ROI_X - 1)         {** 320 **}' for each column X within our region-of-interest (we only care about the left side of the frame - anything on the right is not our laser) 
      index := ((iy * FB_CLR_X) + ix) << 1                 ' calculate index, look at every other byte of the frame buffer
      
      if (BYTE[fbPtr][index] > LOWER_BOUND)                              ' if pixel's Y component is above the lower brightness bound, then pixel is "valid"
        roi[ix] += 1                                        ' so, increment count for the current column
  end := cnt
  Sio.dec(end - start)       ' 23615120 ticks 245 milliseconds
  sio.tx(13)
'********************** partially unrolled loop that uses unswapped data  
  start := cnt
  repeat iy from 0 to constant(FB_CLR_Y - 1)          ' use constant construct, otherwise evaluated every time thru loop
    repeat ix from 0 to constant(ROI_X - 1) step 2    ' **** DANGER **** possible off by one error this line
      index := ((iy * FB_CLR_X) + ix) << 2  + 3                      ' calculate index, get last byte in long
      
      if ( BYTE[fbPtr][index] > LOWER_BOUND)            ' if pixel's Y component is above the lower brightness bound, then pixel is "valid"
        roi[ix] += 1                                        ' so, increment count for the current column
      index -= 2                                          ' get second byte in word
      if ( BYTE[fbPtr][index] > LOWER_BOUND)            ' if pixel's Y component is above the lower brightness bound, then pixel is "valid"
        roi[ix+1] += 1                                        ' so, increment count for the current column
  end := cnt
  Sio.dec(end - start)       ' 19192688 ticks 199 milliseconds + savings of 264 milliseconds by not shuffling data total savings of 392 milliseconds
  sio.tx(13)
      